/* REXX */                                                              
/* SYS1.USER.CLIST(VSAMUTIL) -------------------------------------- */  
/* UTILITY  PER VEDERE, AGGIUNGERE, AGGIORNARE, CANCELLARE RECORD   */  
/* DI FILES VSAM                                                    */  
/* USA LA ROUTINE 'EXECIOVS'                                        */  
/*                                                                  */  
/* PIERO   3/92                                                     */  
/* ---------------------------------------------------------------- */  
ADDRESS TSO                                                             
ARG FILE AZIONE RECORD NREC                                             
IF FILE = '' THEN SIGNAL HELP                                           
IF POS('(',FILE) > 0  THEN DO                                           
   SAY 'VSAMUTIL is only for VSAM files and not for 'FILE
   EXIT 30                                                              
END                                                                     
IF POS('CATALOG',FILE) /= 0 THEN DO                                     
   SAY 'Cannot use VSAMUTIL with a Catalog!'
   EXIT 10                                                              
END                                                                     
FILE = STRIP(TRANSLATE(FILE," ","'"))                                   
  /* CONTROLLA SE E' FILE VSAM */                                       
X = OUTTRAP('TRAPMSG.')   /* PRENDE I MESSAGGI DI 'LISTDS' DAL VIDEO */ 
"LISTDS '"FILE"'"                                                       
X = OUTTRAP('OFF')                                                      
                                                                        
PARSE VALUE TRAPMSG.3 WITH DUMMY DSORG                                  
IF DSORG /= 'VSAM' THEN DO                                              
   SAY "File "FILE" is not a VSAM file."
   EXIT 10                                                              
END                                                                     
/* IF RECORD = '' THEN 'TSOCLEAR'  */ /* <<-- to clear screen */
IF AZIONE = '' THEN DO                                                  
   SAY                                                                  
   SAY "Write what to do with file VSAM  "FILE":"
   SAY                                                                  
   SAY "    1 - BROWSE - View some records      "
   SAY "    2 - ADD    - Add a record (only ESDS or KSDS)    "
   SAY "    3 - UPDATE - Update a record  (only KSDS)       "
   SAY "    4 - DELETE - Delete a record  (only KSDS or RRDS)"
   SAY "        (ENTER to exit) "
   PULL AZIONE                                                          
END                                                                     
IF AZIONE = '' THEN EXIT                                                
SELECT                                                                  
   WHEN (AZIONE = '1' ! POS(AZIONE,'BROWSE') = 1)  THEN DO              
   IF RECORD = '' THEN DO                                               
      SAY 'Write initial key for a KSDS BROWSE in the form:'
      SAY "   '....' o X'....' (in exadecimal)                    "
      SAY 'Write initial record number for a RRDS BROWSE'
      SAY "ENTER for start of file (mandatory for ESDS)"
      PULL RECORD                                                       
      SAY 'Write number of record to view (ENTER for 20 records)'
      PULL NREC                                                         
      IF NREC = '' THEN NREC = 20                                       
      IF DATATYPE(NREC) /= 'NUM' THEN DO                                
         SAY 'Value not numeric: 'NREC
         EXIT 20                                                        
      END                                                               
      IF NREC > 1000  THEN DO                                           
         SAY 'Value too high: 'NREC
         EXIT 10                                                        
      END                                                               
   END                                                                  
   END                                                                  
   WHEN (AZIONE = '2' ! POS(AZIONE,'ADD') = 1)  THEN DO                 
   IF RECORD = '' THEN DO                                               
      SAY 'Write the record to ADD in the form:'
      SAY "   '....'  o  X'....' (in exadecimal)               "
      SAY '(Not valid for RRDS files; ENTER to exit)'
      PULL RECORD                                                       
      IF RECORD = '' THEN EXIT                                          
      END                                                               
   END                                                                  
   WHEN (AZIONE = '3' ! POS(AZIONE,'UPDATE') = 1) THEN DO               
   IF RECORD = '' THEN DO                                               
      SAY 'Write the record to UPDATE in the form:'
      SAY "   '....' o X'....' (in exadecimal)    "
      SAY '(Not valid for RRDS files; ENTER to exit)'
      PULL RECORD                                                       
      IF RECORD = '' THEN EXIT                                          
      END                                                               
   END                                                                  
   WHEN (AZIONE = '4' ! POS(AZIONE,'DELETE') = 1) THEN DO               
   IF RECORD = '' THEN DO                                               
      SAY 'Write the Key of the record to delete, for KSDS, in the form'
      SAY "   '....'  o  X'....' (in exadecimal)         "
      SAY 'Write the number of record to delete, for RRDS'
      SAY '(Not valid for ESDS files; ENTER to exit)'
      PULL RECORD                                                       
      IF RECORD = '' THEN EXIT                                          
      END                                                               
   END                                                                  
   OTHERWHISE                                                           
      SAY 'Action wrong: 'AZIONE'; VSAMUTIL cancelled.'
      EXIT 20                                                           
END                                                                     
RECORD = STRIP(RECORD)                                                  
L = LENGTH(RECORD)                                                      
IF L > 0 THEN DO                                                        
   IF SUBSTR(RECORD,L,1) /= "'" THEN DO                                 
      SAY 'Quotes not closed in 'RECORD'; VSAMUTIL cancelled.'
      EXIT 20                                                           
   END                                                                  
   IF SUBSTR(RECORD,1,1) = "'" THEN                                     
      RECORD = SUBSTR(RECORD,2,L-2)                                     
   ELSE DO                                                              
      IF SUBSTR(RECORD,1,2) = "X'" ! SUBSTR(RECORD,1,2) = "x'" THEN     
         RECORD = SUBSTR(RECORD,3,L-3)                                  
      ELSE DO                                                           
         SAY 'Quotes not opened in 'RECORD'; VSAMUTIL cancelled.'
         EXIT 20                                                        
      END                                                               
   END                                                                  
END                                                                     
IF NREC = '' THEN NREC = 20                                             
"FREE FI(FILEVSAM)"                                                     
"ALLOC FI(FILEVSAM) DA('"FILE"') SHR"                                   
IF RC /= 0 THEN DO                                                      
   SAY 'Error in ALLOC di 'FILE' RC = 'RC                              
   EXIT RC                                                              
END                                                                     
SELECT                                                                  
   WHEN (AZIONE = '1' ! POS(AZIONE,'BROWSE') = 1)  THEN DO              
      /* 'TSOCLEAR' */  /* <<-- to clear screen   */
      SAY 'BROWSE di 'FILE ' ----------------'                          
      IF RECORD /= '' THEN                                              
         "EXECIOVS "NREC" DISKR FILEVSAM RECORD (STEM REC."             
      ELSE "EXECIOVS "NREC" DISKR FILEVSAM (STEM REC."                  
      IF RC = 0 THEN DO                                                 
         DO I = 1 TO REC.0                                              
            SAY SUBSTR(REC.I,1,78)                                      
         END                                                            
      END                                                               
      END                                                               
   WHEN (AZIONE = '2' ! POS(AZIONE,'ADD') = 1)  THEN DO                 
      REC.1 = RECORD                                                    
      "EXECIOVS 1 DISKW FILEVSAM (STEM REC."                            
      END                                                               
   WHEN (AZIONE = '3' ! POS(AZIONE,'UPDATE') = 1) THEN DO               
      REC.1 = RECORD                                                    
      "EXECIOVS 1 DISKU FILEVSAM (STEM REC."                            
      END                                                               
   WHEN (AZIONE = '4' ! POS(AZIONE,'DELETE') = 1) THEN DO               
      CHIAVE = RECORD                                                   
      "EXECIOVS 1 DISKD FILEVSAM CHIAVE "                               
      END                                                               
   OTHERWHISE                                                           
END                                                                     
RETCODE = RC                                                            
"FREE FI(FILEVSAM)"                                                     
SAY ' RC = 'RETCODE                                                     
                                                                        
EXIT                                                                    
                                                                        
HELP:                                                                   
/* 'TSOCLEAR' */  /* << -- to clear screen, if you have this utility */
SAY 'VSAMUTIL --------------------------------------------------------' 
SAY 'Utility to View, Add, Update, Delete records from VSAM files     '
SAY 'in interactive mode.                                             '
SAY                                                                     
SAY 'Use:'
SAY                                                                     
SAY '    VSAMUTIL  <name.cluster.vsam>  <action>  <record>   '
SAY                                                                     
SAY "<action> can be: BROWSE, ADD, UPDATE, DELETE; if <action> or"
SAY '<record> are omitted, are requested interactly.  '
SAY                                                                     
SAY '-----------------------------------------------------------------' 
                                                                        
EXIT                                                                    
